/*
idt_routines.hpp - IDT routine helper structures

This file is a part of Fiku.
Copyright (C) 2021 Akib Azmain Turja

Fiku is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Fiku is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Authors: Akib Azmain Turja
*/

#pragma once

#include <stdint.h>

namespace idt_routine
{

  // Structure for holding registers pushed by low-level assembly handler
  struct interrupt_frame
  {
    uint32_t ds;
    uint32_t edi;
    uint32_t esi;
    uint32_t edx;
    uint32_t ecx;
    uint32_t ebx;
    uint32_t eax;
    uint32_t ebp;
    uint32_t interrupt;
    uint32_t code;
    uint32_t eip;
    uint32_t cs;
    uint32_t eflags;

    // Only used if RPL in %cs != 0, otherwise modification is undefined
    uint32_t esp;
    uint32_t ss;
  };
}
