/*
io.cpp - I/O port related C function implementations

This file is a part of Fiku.
Copyright (C) 2021 Akib Azmain Turja

Fiku is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Fiku is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Authors: Akib Azmain Turja
*/

#include <fiku/io.h>

void
io_outb (uint8_t data, uint16_t port)
{
  asm volatile ("outb %0, %1"
                :
                : "a" (data), "dN" (port));
}

uint8_t
io_inb (uint16_t port)
{
  uint8_t ret;
  asm ("inb %1, %0"
       : "=a" (ret)
       : "dN" (port));
  return ret;
}
