/*
hacks.cpp - Various hacks for i386 architecture to prevent the toolchain
from doing things it thinks best

This file is a part of Fiku.
Copyright (C) 2021 Akib Azmain Turja

Fiku is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Fiku is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Authors: Akib Azmain Turja
*/

// NOTE: Functions in this file are never meant for use, these are only to
// prevent the linker discarding essensial symbols

// Multiboot2 header
extern char multiboot2_header_[0];

namespace
{

  // Without this, the linker would optimize away the Multiboot2 header as
  // it is in a static library and it isn't touched by the main executable
  __attribute__ ((used)) void *
  preserve_multiboot_header ()
  {
    return multiboot2_header_;
  }

  __attribute__ ((used)) void
  preserve_init_fini_end ()
  {
    asm volatile ("call _init_end;"
                  "call _fini_end;");
  }
}
