/*
context_switch.cpp - Switch kernel contexts

This file is a part of Fiku.
Copyright (C) 2021 Akib Azmain Turja

Fiku is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Fiku is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Authors: Akib Azmain Turja
*/

  .global context_switch
  .type context_switch, @function
context_switch:
  movl 4(%esp), %eax
  movl 8(%esp), %edx
  jmp context_store
  .size context_switch, . - context_switch

context_store:
  pushl %ebp
  pushl %edi
  pushl %esi
  pushl %ebx
  movl %esp, (%eax)
  jmp context_load
  .size context_store, . - context_store

  .global context_load
  .type context_load, @function
context_load:
  movl %edx, %esp
  popl %ebx
  popl %esi
  popl %edi
  popl %ebp
  ret
  .size context_load, . - context_load
