/*
spinlock.h - Spinlock interface

This file is a part of Fiku.
Copyright (C) 2021 Akib Azmain Turja

Fiku is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Fiku is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Authors: Akib Azmain Turja
*/

#pragma once

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct
{
  volatile bool locked;
} spnlk_t;

enum
  {
    spnlk_success,
    spnlk_error,
    spnlk_busy
  };

int
spnlk_init (spnlk_t *lock);

int
spnlk_trylock (spnlk_t *lock);

int
spnlk_lock (spnlk_t *lock);

int
spnlk_unlock (spnlk_t *lock);

int
spnlk_destroy (spnlk_t *lock);

#ifdef __cplusplus
}
#endif
