/*
pit.cpp - Interface for the Programmable Interval Timer

This file is a part of Fiku.
Copyright (C) 2021 Akib Azmain Turja

Fiku is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Fiku is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Authors: Akib Azmain Turja
*/

#pragma once

#include <fiku/timers/base.hpp>

namespace timer
{
  class pit_t : public basic_timer
  {
  public:
    pit_t ();
    ~pit_t () = default;

    // Set the PIT to call handler every interval millisecond
    void
    set (size_t interval, handler_t handler = nullptr);

    // Start the timer
    void
    start ();

    // Read the time elapsed
    size_t
    read () const;

    // Stop the timer
    virtual void
    stop ();
  };

  extern pit_t pit;
}
