/*
stdlib.h - Standard utility C functions

This file is a part of Fiku.
Copyright (C) 2021 Akib Azmain Turja

Fiku is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Fiku is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Authors: Akib Azmain Turja
*/

#pragma once

#include <stddef.h>

#ifdef __cplusplus
extern "C"
{
#endif

#define LIBC_ABS
int
abs (int x);

#define LIBC_LABS
long
labs (long x);

#define LIBC_ATOI
int
atoi (const char *str);

#define LIBC_ATOL
long
atol (const char *str);

#ifndef __i386__
#define LIBC_ATOLL
long long
atoll (const char *str);
#endif

#define LIBC_MALLOC
void *
malloc (size_t size);

#define LIBC_CALLOC
void *
calloc (size_t num, size_t size);

#define LIBC_REALLOC
void *
realloc (void *ptr, size_t size);

#define LIBC_FREE
void
free (void *ptr);

#define LIBC_ALIGNED_ALLOC
void *
aligned_alloc (size_t alignment, size_t size);

#define LIBC_ALIGNED_REALLOC
void *
aligned_realloc (size_t alignment, void *ptr, size_t size);

#ifdef __cplusplus
}
#endif
